Module javafx.graphics
Package javafx.scene

# Enum AccessibleAttribute

java.lang.Object
java.lang.Enum<AccessibleAttribute>
javafx.scene.AccessibleAttribute

All Implemented Interfaces:
  `Serializable`, `Comparable<AccessibleAttribute>`, `Constable`

    public enum AccessibleAttribute
    extends Enum<AccessibleAttribute>

This enum describes the attributes that an assistive technology such as a screen reader can request from the scene graph. The `AccessibleRole` dictates the set of attributes that the screen reader will request for a particular control. For example, a slider is expected to return a double that represents the current value.

Attributes may have any number of parameters, depending on the particular attribute.

When the value of an attribute is changed by a node, it must notify the assistive technology using `Node.notifyAccessibleAttributeChanged(AccessibleAttribute)`. This will allow the screen reader to inform the user that a value has changed. The most common form of notification is focus change.

Since:
  JavaFX 8u40
See Also:
  `Node.queryAccessibleAttribute(AccessibleAttribute, Object...)`, `Node.notifyAccessibleAttributeChanged(AccessibleAttribute)`, `AccessibleRole`, `ROLE`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant | Description
  --- | ---
  `ACCELERATOR` | Returns the accelerator for the node.
  `BOUNDS` | Returns the bounds for the node.
  `BOUNDS_FOR_RANGE` | Returns the array of bounding rectangles for the given character range.
  `CARET_OFFSET` | Returns the caret offset for the node.
  `CELL_AT_ROW_COLUMN` | Returns the cell at the given row and column indices.
  `CHILDREN` | Returns the children for the node.
  `COLUMN_AT_INDEX` | Returns the column at the given index.
  `COLUMN_COUNT` | Returns the column count for the node.
  `COLUMN_INDEX` | Returns the column index for the node.
  `CONTENTS` | Returns the contents of the node.
  `DATE` | Returns the local date for the node.
  `DISABLED` | Returns true if the node is disabled, otherwise false.
  `DISCLOSURE_LEVEL` | Returns the depth of a row in the disclosure hierarchy.
  `EDITABLE` | Returns true if the node is editable, otherwise false.
  `EXPANDED` | Returns true if the node is expanded, otherwise false.
  `FOCUS_ITEM` | Returns the focus item.
  `FOCUS_NODE` | Returns the focus node.
  `FOCUSED` | Returns true if the node is focused, otherwise false.
  `FONT` | Returns the font for the node.
  `HEADER` | Returns the header for the node.
  `HELP` | Returns the help text for the node.
  `HORIZONTAL_SCROLLBAR` | Returns the horizontal scroll bar for the node.
  `INDETERMINATE` | Returns true of the node is indeterminaite, otherwise false.
  `INDEX` | Returns the index for the node.
  `ITEM_AT_INDEX` | Returns the item at the given index.
  `ITEM_COUNT` | Returns the item count for the node.
  `LABELED_BY` | Returns the node that is the label for this node.
  `LEAF` | Returns true if the node is a leaf element, otherwise false.
  `LINE_END` | Returns the line end offset of the given line index.
  `LINE_FOR_OFFSET` | Returns the line index of the given character offset.
  `LINE_START` | Returns the line start offset of the given line index.
  `MAX_VALUE` | Returns the maximum value for the node.
  `MIN_VALUE` | Returns the minimum value for the node.
  `MNEMONIC` | Returns the mnemonic for the node.
  `MULTIPLE_SELECTION` | Returns true if the node allows for multiple selection, otherwise false.
  `NODE_AT_POINT` | Returns the node at the given location.
  `OFFSET_AT_POINT` | Returns the character offset at the given location.
  `ORIENTATION` | Returns the orientation of the node.
  `OVERFLOW_BUTTON` | Return the overflow button for the node.
  `PARENT` | Returns the parent for the node.
  `PARENT_MENU` | Returns the parent menu for the node.
  `ROLE` | Returns the role for the node.
  `ROLE_DESCRIPTION` | Returns the role description for the node.
  `ROW_AT_INDEX` | Returns the row at the given index.
  `ROW_COUNT` | Returns the row count for the node.
  `ROW_INDEX` | Returns the row index of the node.
  `SCENE` | Returns the scene for the node.
  `SELECTED` | Returns true if the node is selected, otherwise false.
  `SELECTED_ITEMS` | Returns the list of selected items for the node.
  `SELECTION_END` | Returns the text selection end offset for the node.
  `SELECTION_START` | Returns the text selection start offset for the node.
  `SUBMENU` | Returns the sub menu for the node.
  `TEXT` | Returns the text for the node.
  `TREE_ITEM_AT_INDEX` | Returns a tree item at the given index, relative to its TREE_ITEM_PARENT.
  `TREE_ITEM_COUNT` | Returns the tree item count for the node, relative to its TREE_ITEM_PARENT.
  `TREE_ITEM_PARENT` | Returns the parent item for the item, or null if the item is the root.
  `VALUE` | Returns the value for the node.
  `VERTICAL_SCROLLBAR` | Returns the vertical scroll bar for the node.
  `VISIBLE` | Returns true if node is visible, otherwise false.
  `VISITED` | Returns true if the node has been visited, otherwise false.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `Class<?>` | `getReturnType()` |
  `static AccessibleAttribute` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
  `static AccessibleAttribute[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### ACCELERATOR

    public static final AccessibleAttribute ACCELERATOR
    Returns the accelerator for the node.
    - Used by: Menu, MenuItem, RadioMenuItem, and others
    - Needs notify: no
    - Return Type: `KeyCombination`
    - Parameters:

  - ### BOUNDS

    public static final AccessibleAttribute BOUNDS
    Returns the bounds for the node.
    - Used by: Node
    - Needs notify: no
    - Return Type: `Bounds`
    - Parameters:

  - ### BOUNDS_FOR_RANGE

    public static final AccessibleAttribute BOUNDS_FOR_RANGE
    Returns the array of bounding rectangles for the given character range.
    - Used by: TextField and TextArea
    - Needs notify: no
    - Return Type: `Bounds`[]
    - Parameters:
      - `Integer` the start offset
      - `Integer` the end offset

  - ### CARET_OFFSET

    public static final AccessibleAttribute CARET_OFFSET
    Returns the caret offset for the node.
    - Used by: TextField and TextArea
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### CHILDREN

    public static final AccessibleAttribute CHILDREN
    Returns the children for the node.
    - Used by: Parent
    - Needs notify: no
    - Return Type: `ObservableList`<`Node`>
    - Parameters:

  - ### COLUMN_AT_INDEX

    public static final AccessibleAttribute COLUMN_AT_INDEX
    Returns the column at the given index.
    - Used by: TableView and TreeTableView
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:
      - `Integer` the index

  - ### CELL_AT_ROW_COLUMN

    public static final AccessibleAttribute CELL_AT_ROW_COLUMN
    Returns the cell at the given row and column indices.
    - Used by: TableView and TreeTableView
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:
      - `Integer` the row index
      - `Integer` the column index

  - ### COLUMN_COUNT

    public static final AccessibleAttribute COLUMN_COUNT
    Returns the column count for the node.
    - Used by: TableView and TreeTableView
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### COLUMN_INDEX

    public static final AccessibleAttribute COLUMN_INDEX
    Returns the column index for the node.
    - Used by: TableCell and TreeTableCell
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### CONTENTS

    public static final AccessibleAttribute CONTENTS
    Returns the contents of the node.
    - Used by: ScrollPane
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### DISABLED

    public static final AccessibleAttribute DISABLED
    Returns true if the node is disabled, otherwise false.
    - Used by: Node
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

  - ### DISCLOSURE_LEVEL

    public static final AccessibleAttribute DISCLOSURE_LEVEL
    Returns the depth of a row in the disclosure hierarchy.
    - Used by: TreeItem and TreeTableRow
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### DATE

    public static final AccessibleAttribute DATE
    Returns the local date for the node.
    - Used by: DatePicker
    - Needs notify: no
    - Return Type: `LocalDate`
    - Parameters:

  - ### EDITABLE

    public static final AccessibleAttribute EDITABLE
    Returns true if the node is editable, otherwise false.
    - Used by: TextField, ComboBox, and others
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

  - ### EXPANDED

    public static final AccessibleAttribute EXPANDED
    Returns true if the node is expanded, otherwise false.
    - Used by: TreeItem, TitledPane, and others
    - Needs notify: yes
    - Return Type: `Boolean`
    - Parameters:

  - ### FOCUS_ITEM

    public static final AccessibleAttribute FOCUS_ITEM
    Returns the focus item.

    Used for controls such as TabPane, TableView, ListView where the assistive technology focus is different from the normal focus node. For example, a table control will have focus, while a cell inside the table might have the screen reader focus.

    - Used by: ListView, TabPane, and others
    - Needs notify: yes
    - Return Type: `Node`
    - Parameters:

  - ### FOCUS_NODE

    public static final AccessibleAttribute FOCUS_NODE
    Returns the focus node. Type: Node

    When this attribute is requested from the Scene, the default implementation returns `Scene.focusOwnerProperty()`.

    - Used by: Scene
    - Needs notify: yes
    - Return Type: `Node`
    - Parameters:

  - ### FOCUSED

    public static final AccessibleAttribute FOCUSED
    Returns true if the node is focused, otherwise false.
    - Used by: Node
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

  - ### FONT

    public static final AccessibleAttribute FONT
    Returns the font for the node.
    - Used by: TextField and TextArea
    - Needs notify: no
    - Return Type: `Font`
    - Parameters:

  - ### HEADER

    public static final AccessibleAttribute HEADER
    Returns the header for the node.
    - Used by: TableView and TreeTableView
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### HELP

    public static final AccessibleAttribute HELP
    Returns the help text for the node.
    - Used by: Node
    - Needs notify: no
    - Return Type: `String`
    - Parameters:

  - ### HORIZONTAL_SCROLLBAR

    public static final AccessibleAttribute HORIZONTAL_SCROLLBAR
    Returns the horizontal scroll bar for the node.
    - Used by: ListView, ScrollPane, and others
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### INDETERMINATE

    public static final AccessibleAttribute INDETERMINATE
    Returns true of the node is indeterminaite, otherwise false.
    - Used by: CheckBox and ProgressIndicator
    - Needs notify: yes
    - Return Type: `Boolean`
    - Parameters:

  - ### ITEM_AT_INDEX

    public static final AccessibleAttribute ITEM_AT_INDEX
    Returns the item at the given index.
    - Used by: TabPane, ListView, and others
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:
      - `Integer` the index

  - ### ITEM_COUNT

    public static final AccessibleAttribute ITEM_COUNT
    Returns the item count for the node.
    - Used by: TabPane, ListView, and others
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### INDEX

    public static final AccessibleAttribute INDEX
    Returns the index for the node.
    - Used by: ListItem, TableRow, and others
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### LABELED_BY

    public static final AccessibleAttribute LABELED_BY
    Returns the node that is the label for this node.

    When `labelFor` is set, the default implementation of `LABELED_BY` uses this relationship to return the appropriate node to the screen reader.

    - Used by: Node
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### LEAF

    public static final AccessibleAttribute LEAF
    Returns true if the node is a leaf element, otherwise false.
    - Used by: TreeItem and TreeTableRow
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

  - ### LINE_END

    public static final AccessibleAttribute LINE_END
    Returns the line end offset of the given line index.
    - Used by: TextArea
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:
      - `Integer` the line index

  - ### LINE_FOR_OFFSET

    public static final AccessibleAttribute LINE_FOR_OFFSET
    Returns the line index of the given character offset.
    - Used by: TextArea
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:
      - `Integer` the character offset

  - ### LINE_START

    public static final AccessibleAttribute LINE_START
    Returns the line start offset of the given line index.
    - Used by: TextArea
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:
      - `Integer` the line index

  - ### MIN_VALUE

    public static final AccessibleAttribute MIN_VALUE
    Returns the minimum value for the node.
    - Used by: Slider, ScrollBar, and others
    - Needs notify: no
    - Return Type: `Double`
    - Parameters:

  - ### MAX_VALUE

    public static final AccessibleAttribute MAX_VALUE
    Returns the maximum value for the node.
    - Used by: Slider, ScrollBar, and others
    - Needs notify: no
    - Return Type: `Double`
    - Parameters:

  - ### MNEMONIC

    public static final AccessibleAttribute MNEMONIC
    Returns the mnemonic for the node.
    - Used by: Menu, MenuItem, CheckMenuItem, and others
    - Needs notify: no
    - Return Type: `String`
    - Parameters:

  - ### MULTIPLE_SELECTION

    public static final AccessibleAttribute MULTIPLE_SELECTION
    Returns true if the node allows for multiple selection, otherwise false.
    - Used by: ListView, TableView, and others
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

  - ### NODE_AT_POINT

    public static final AccessibleAttribute NODE_AT_POINT
    Returns the node at the given location.
    - Used by: Scene
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:
      - `Point2D` the point location

  - ### OFFSET_AT_POINT

    public static final AccessibleAttribute OFFSET_AT_POINT
    Returns the character offset at the given location.
    - Used by: TextField and TextArea
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:
      - `Point2D` the point location

  - ### ORIENTATION

    public static final AccessibleAttribute ORIENTATION
    Returns the orientation of the node.
    - Used by: ScrolBar and Slider
    - Needs notify: no
    - Return Type: `Orientation`
    - Parameters:

  - ### OVERFLOW_BUTTON

    public static final AccessibleAttribute OVERFLOW_BUTTON
    Return the overflow button for the node.
    - Used by: Toolbar
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### PARENT

    public static final AccessibleAttribute PARENT
    Returns the parent for the node.
    - Used by: Node
    - Needs notify: yes
    - Return Type: `Parent`
    - Parameters:

  - ### PARENT_MENU

    public static final AccessibleAttribute PARENT_MENU
    Returns the parent menu for the node.
    - Used by: ContextMenu
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### ROLE

    public static final AccessibleAttribute ROLE
    Returns the role for the node.
    - Used by: Node
    - Needs notify: no
    - Return Type: `AccessibleRole`
    - Parameters:

  - ### ROLE_DESCRIPTION

    public static final AccessibleAttribute ROLE_DESCRIPTION
    Returns the role description for the node.
    - Used by: Node
    - Needs notify: no
    - Return Type: `String`
    - Parameters:

  - ### ROW_AT_INDEX

    public static final AccessibleAttribute ROW_AT_INDEX
    Returns the row at the given index.
    - Used by: TableView, TreeView, and TreeTableView
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:
      - `Integer` the row index

  - ### ROW_COUNT

    public static final AccessibleAttribute ROW_COUNT
    Returns the row count for the node.
    - Used by: TableView, TreeView, and TreeTableView
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### ROW_INDEX

    public static final AccessibleAttribute ROW_INDEX
    Returns the row index of the node.
    - Used by: TableCell, TreeItem, and TreeTableCell
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### SCENE

    public static final AccessibleAttribute SCENE
    Returns the scene for the node.
    - Used by: Node
    - Needs notify: no
    - Return Type: `Scene`
    - Parameters:

  - ### SELECTED

    public static final AccessibleAttribute SELECTED
    Returns true if the node is selected, otherwise false.
    - Used by: CheckBox, TreeItem, and others
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

  - ### SELECTED_ITEMS

    public static final AccessibleAttribute SELECTED_ITEMS
    Returns the list of selected items for the node.
    - Used by: ListView, TableView, and others
    - Needs notify: no
    - Return Type: `ObservableList`<`Node`>
    - Parameters:

  - ### SELECTION_END

    public static final AccessibleAttribute SELECTION_END
    Returns the text selection end offset for the node.
    - Used by: TextField and TextArea
    - Needs notify: yes
    - Return Type: `Integer`
    - Parameters:

  - ### SELECTION_START

    public static final AccessibleAttribute SELECTION_START
    Returns the text selection start offset for the node.
    - Used by: TextField and TextArea
    - Needs notify: yes
    - Return Type: `Integer`
    - Parameters:

  - ### SUBMENU

    public static final AccessibleAttribute SUBMENU
    Returns the sub menu for the node.
    - Used by: Menu
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### TEXT

    public static final AccessibleAttribute TEXT
    Returns the text for the node. E.g.
    - ComboBox returns a string representation of the current selected item.
    - TextField returns the contents of the text field.
    - Used by: Node
    - Needs notify: yes
    - Return Type: `String`
    - Parameters:

  - ### TREE_ITEM_AT_INDEX

    public static final AccessibleAttribute TREE_ITEM_AT_INDEX
    Returns a tree item at the given index, relative to its TREE_ITEM_PARENT.
    - Used by: TreeItem and TreeTableRow
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:
      - `Integer` the index

  - ### TREE_ITEM_COUNT

    public static final AccessibleAttribute TREE_ITEM_COUNT
    Returns the tree item count for the node, relative to its TREE_ITEM_PARENT.
    - Used by: TreeItem and TreeTableRow
    - Needs notify: no
    - Return Type: `Integer`
    - Parameters:

  - ### TREE_ITEM_PARENT

    public static final AccessibleAttribute TREE_ITEM_PARENT
    Returns the parent item for the item, or null if the item is the root.
    - Used by: TreeItem and TreeTableRow
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### VALUE

    public static final AccessibleAttribute VALUE
    Returns the value for the node.
    - Used by: Slider, ScrollBar, Thumb, and others
    - Needs notify: yes
    - Return Type: `Double`
    - Parameters:

  - ### VERTICAL_SCROLLBAR

    public static final AccessibleAttribute VERTICAL_SCROLLBAR
    Returns the vertical scroll bar for the node.
    - Used by: ListView, ScrollPane, and others
    - Needs notify: no
    - Return Type: `Node`
    - Parameters:

  - ### VISIBLE

    public static final AccessibleAttribute VISIBLE
    Returns true if node is visible, otherwise false.
    - Used by: Node and ContextMenu
    - Needs notify: yes
    - Return Type: `Boolean`
    - Parameters:

  - ### VISITED

    public static final AccessibleAttribute VISITED
    Returns true if the node has been visited, otherwise false.
    - Used by: Hyperlink
    - Needs notify: no
    - Return Type: `Boolean`
    - Parameters:

- ## Method Details

  - ### values

    public static AccessibleAttribute[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static AccessibleAttribute valueOf​(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getReturnType

    public Class<?> getReturnType()